<!DOCTYPE html>
<html>
  <head>
    <title>FarmBuddy Sensor Data</title>
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
  </head>
  <body>
    <canvas id="myChart"></canvas>
    <script>
      function renderChart(data) {
        const labels = data.map(obj => obj.msg.device_id);
        const tempData = data.map(obj => obj.msg.temp);
        const humidData = data.map(obj => obj.msg.humid);
        const heatIndexData = data.map(obj => obj.msg.heatIndex);
        const datetimeData = data.map(obj => new Date(obj.timestamp).toLocaleString());
        const idData = data.map(obj => obj.msg.gateway);

        const ctx = document.getElementById('myChart').getContext('2d');
        const chart = new Chart(ctx, {
          type: 'bar',
          data: {
            labels: labels,
            datasets: [
              {
                label: 'Temperature (C)',
                data: tempData,
                backgroundColor: 'rgba(255, 99, 132, 0.2)',
                borderColor: 'rgba(255, 99, 132, 1)',
                borderWidth: 1
              },
              {
                label: 'Humidity (%)',
                data: humidData,
                backgroundColor: 'rgba(54, 162, 235, 0.2)',
                borderColor: 'rgba(54, 162, 235, 1)',
                borderWidth: 1
              },
              {
                label: 'Heat Index (C)',
                data: heatIndexData,
                backgroundColor: 'rgba(255, 206, 86, 0.2)',
                borderColor: 'rgba(255, 206, 86, 1)',
                borderWidth: 1
              }
            ]
          },
          options: {
            scales: {
              yAxes: [{
                ticks: {
                  beginAtZero: true
                }
              }],
              xAxes: [{
                type: 'time',
                time: {
                  unit: 'minute',
                  displayFormats: {
                    minute: 'MMM D, h:mm a'
                  }
                },
                ticks: {
                  source: 'labels'
                }
              }]
            },
            tooltips: {
              callbacks: {
                label: function(tooltipItem, data) {
                  var label = data.datasets[tooltipItem.datasetIndex].label || '';
                  if (label) {
                    label += ': ';
                  }
                  label += tooltipItem.yLabel;
                  if (tooltipItem.datasetIndex == 0) {
                    label += 'C';
                  } else if (tooltipItem.datasetIndex == 1) {
                    label += '%';
                  }
                  return label;
                }
              }
            }
          }
        });
      }

      fetch('/data')
        .then(res => res.json())
        .then(data => {
          renderChart(data);
        });

      // Fetch new data every 10 seconds
      setInterval(() => {
        fetch('/data')
          .then(res => res.json())
          .then(data => {
            renderChart(data);
          });
      }, 10000);
    </script>
  </body>
</html>
